Horizontal BoxPlot with Points in JavaScript

Using ApexCharts with JavaScript

This Horizontal BoxPlot with Points example uses ApexCharts.js directly in JavaScript, with no wrapper component.

Install it with npm install apexcharts, then mount the chart with new ApexCharts(element, options).render().

JavaScript installation guide
// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(98761234)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function quantile(sorted, q) {
  var pos = (sorted.length - 1) * q
  var b = Math.floor(pos)
  var r = pos - b
  return sorted[b + 1] !== undefined
    ? sorted[b] + r * (sorted[b + 1] - sorted[b])
    : sorted[b]
}

// For each region draw a sample, then derive both the 5-number summary (the box)
// and keep the raw observations (the overlaid points).
function buildBox(name, n, mean, sd) {
  var data = []
  for (var i = 0; i < n; i++) data.push(Math.round(gauss(mean, sd) * 10) / 10)
  var s = data.slice().sort(function (a, b) {
    return a - b
  })
  return {
    x: name,
    y: [
      s[0],
      quantile(s, 0.25),
      quantile(s, 0.5),
      quantile(s, 0.75),
      s[s.length - 1],
    ],
    points: data,
  }
}

var REGIONS = [
  buildBox('North', 45, 68, 8),
  buildBox('South', 45, 74, 6),
  buildBox('East', 45, 61, 11),
  buildBox('West', 45, 70, 7),
]

var options = {
  series: [
    {
      name: 'Response time',
      type: 'boxPlot',
      data: REGIONS,
    },
  ],
  chart: {
    type: 'boxPlot',
    height: 460,
  },
  title: {
    text: 'Response time distribution by region',
  },
  plotOptions: {
    bar: {
      horizontal: true,
      barHeight: '50%',
    },
    boxPlot: {
      colors: { upper: '#5b8def', lower: '#a3c0f9' },
      // overlay each raw observation as a jittered dot
      points: { show: true, size: 3, jitter: 0.6 },
    },
  },
  stroke: { colors: ['#37474f'] },
}

var chart = new ApexCharts(document.querySelector('#chart'), options)
chart.render()

Horizontal BoxPlot with Points in Angular

Using ApexCharts with Angular

This Horizontal BoxPlot with Points example wires ApexCharts into Angular through the ng-apexcharts component.

Install it with npm install ng-apexcharts apexcharts, then mount the chart with <apx-chart [series]="series" [chart]="chart"></apx-chart>.

Angular charts guide

This demo uses imperative chart updates. The generated code is a faithful Angular translation: open it in CodeSandbox to run and tweak.

import { Component, AfterViewInit, OnDestroy, ViewChild } from '@angular/core';
import {
  ChartComponent,
  ApexAxisChartSeries,
  ApexNonAxisChartSeries,
  ApexChart,
  ApexXAxis,
  ApexYAxis,
  ApexTitleSubtitle,
  ApexDataLabels,
  ApexStroke,
  ApexFill,
  ApexLegend,
  ApexTooltip,
  ApexMarkers,
  ApexPlotOptions,
  ApexResponsive,
  ApexGrid,
  ApexAnnotations,
  ApexStates,
  ApexTheme,
  NgApexchartsModule,
} from 'ng-apexcharts';

export type ChartOptions = {
  series?: ApexAxisChartSeries | ApexNonAxisChartSeries;
  chart?: ApexChart;
  xaxis?: ApexXAxis;
  yaxis?: ApexYAxis | ApexYAxis[];
  title?: ApexTitleSubtitle;
  subtitle?: ApexTitleSubtitle;
  dataLabels?: ApexDataLabels;
  stroke?: ApexStroke;
  fill?: ApexFill;
  legend?: ApexLegend;
  tooltip?: ApexTooltip;
  markers?: ApexMarkers;
  plotOptions?: ApexPlotOptions;
  responsive?: ApexResponsive[];
  grid?: ApexGrid;
  annotations?: ApexAnnotations;
  states?: ApexStates;
  theme?: ApexTheme;
  colors?: string[];
  labels?: any;
};

@Component({
  selector: 'app-chart',
  standalone: true,
  imports: [NgApexchartsModule],
  templateUrl: './chart.component.html',
})
export class AppChart implements AfterViewInit, OnDestroy {
  @ViewChild('chart') chart!: ChartComponent;
  private mulberry32 = (a: any): any => {
          return function () {
            a |= 0
            a = (a + 0x6d2b79f5) | 0
            var t = Math.imul(a ^ (a >>> 15), 1 | a)
            t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
            return ((t ^ (t >>> 14)) >>> 0) / 4294967296
          }
        };

  private rng: any = this.mulberry32(98761234);

  private gauss = (mean: any, sd: any): any => {
          var u = 0,
            v = 0
          while (u === 0) u = this.rng()
          while (v === 0) v = this.rng()
          return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
        };

  private quantile = (sorted: any, q: any): any => {
          var pos = (sorted.length - 1) * q
          var b = Math.floor(pos)
          var r = pos - b
          return sorted[b + 1] !== undefined
            ? sorted[b] + r * (sorted[b + 1] - sorted[b])
            : sorted[b]
        };

  private buildBox = (name: any, n: any, mean: any, sd: any): any => {
          var data = []
          for (var i = 0; i < n; i++) data.push(Math.round(this.gauss(mean, sd) * 10) / 10)
          var s = data.slice().sort(function (a, b) {
            return a - b
          })
          return {
            x: name,
            y: [
              s[0],
              this.quantile(s, 0.25),
              this.quantile(s, 0.5),
              this.quantile(s, 0.75),
              s[s.length - 1],
            ],
            points: data,
          }
        };

  private REGIONS: any = [
          this.buildBox('North', 45, 68, 8),
          this.buildBox('South', 45, 74, 6),
          this.buildBox('East', 45, 61, 11),
          this.buildBox('West', 45, 70, 7),
        ];

  public chartOptions: Partial<ChartOptions> = {
          series: [
            {
              name: 'Response time',
              type: 'boxPlot',
              data: this.REGIONS,
            },
          ],
          chart: {
            type: 'boxPlot',
            height: 460,
          },
          title: {
            text: 'Response time distribution by region',
          },
          plotOptions: {
            bar: {
              horizontal: true,
              barHeight: '50%',
            },
            boxPlot: {
              colors: { upper: '#5b8def', lower: '#a3c0f9' },
              // overlay each raw observation as a jittered dot
              points: { show: true, size: 3, jitter: 0.6 },
            },
          },
          stroke: { colors: ['#37474f'] },
        };
  ngAfterViewInit() {
    (window as any).ApexCharts.setLicense('APEX-eyJleHBpcnlEYXRlIjoiMjEyNi0wNy0wNCIsImlzc3VlRGF0ZSI6IjIwMjYtMDctMjgiLCJwbGFuIjoicHJlbWl1bSIsImRvbWFpbnMiOlsiYXBleGNoYXJ0cy5jb20iLCIxMjcuMC4wLjEiLCJsb2NhbGhvc3QiXSwic2lnIjoieVBmb1VCc0Z3TU9ZdUEyaEZkR0I2Y1FtZ0JITUtXcVdJSjB2NVRESXRZbFR3eDJMUmh6R2x0RUc3VXJ4X0s3b25ZMWRZb2Z2VGItN01ydFYyNDVyOWcifQ==');
  }

  ngOnDestroy() {
    // no cleanup needed
  }
}

Horizontal BoxPlot with Points in Vue

Using ApexCharts with Vue

This Horizontal BoxPlot with Points example wires ApexCharts into Vue through the vue3-apexcharts component.

Install it with npm install vue3-apexcharts apexcharts, then mount the chart with <apexchart type="..." :options="options" :series="series" />.

Vue charts guide
<template>
  <div>
    <div id="chart">
      <apexchart
        type="boxPlot"
        height="460"
        :options="chartOptions"
        :series="series"
      ></apexchart>
    </div>
  </div>
</template>

<script>
import VueApexCharts from 'vue-apexcharts'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(98761234)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function quantile(sorted, q) {
  var pos = (sorted.length - 1) * q
  var b = Math.floor(pos)
  var r = pos - b
  return sorted[b + 1] !== undefined
    ? sorted[b] + r * (sorted[b + 1] - sorted[b])
    : sorted[b]
}

// For each region draw a sample, then derive both the 5-number summary (the box)
// and keep the raw observations (the overlaid points).
function buildBox(name, n, mean, sd) {
  var data = []
  for (var i = 0; i < n; i++) data.push(Math.round(gauss(mean, sd) * 10) / 10)
  var s = data.slice().sort(function (a, b) {
    return a - b
  })
  return {
    x: name,
    y: [
      s[0],
      quantile(s, 0.25),
      quantile(s, 0.5),
      quantile(s, 0.75),
      s[s.length - 1],
    ],
    points: data,
  }
}

var REGIONS = [
  buildBox('North', 45, 68, 8),
  buildBox('South', 45, 74, 6),
  buildBox('East', 45, 61, 11),
  buildBox('West', 45, 70, 7),
]

export default {
  components: {
    apexchart: VueApexCharts,
  },
  data: function () {
    return {
      series: [
        {
          name: 'Response time',
          type: 'boxPlot',
          data: REGIONS,
        },
      ],
      chartOptions: {
        chart: {
          type: 'boxPlot',
          height: 460,
        },
        title: {
          text: 'Response time distribution by region',
        },
        plotOptions: {
          bar: {
            horizontal: true,
            barHeight: '50%',
          },
          boxPlot: {
            colors: { upper: '#5b8def', lower: '#a3c0f9' },
            // overlay each raw observation as a jittered dot
            points: { show: true, size: 3, jitter: 0.6 },
          },
        },
        stroke: { colors: ['#37474f'] },
      },
    }
  },
}
</script>

<style>
#chart {
  max-width: 760px;
  margin: 20px auto;
}
</style>

Horizontal BoxPlot with Points in React

Using ApexCharts with React

This Horizontal BoxPlot with Points example wires ApexCharts into React through the react-apexcharts component.

Install it with npm install react-apexcharts apexcharts, then mount the chart with <Chart type="..." options={options} series={series} />.

React charts guide
import React from 'react'
import ReactApexChart from 'react-apexcharts'
import './styles.css'

// ── Reproducible synthetic data (seeded PRNG, no network) ──────────────
function mulberry32(a) {
  return function () {
    a |= 0
    a = (a + 0x6d2b79f5) | 0
    var t = Math.imul(a ^ (a >>> 15), 1 | a)
    t = (t + Math.imul(t ^ (t >>> 7), 61 | t)) ^ t
    return ((t ^ (t >>> 14)) >>> 0) / 4294967296
  }
}
var rng = mulberry32(98761234)

function gauss(mean, sd) {
  var u = 0,
    v = 0
  while (u === 0) u = rng()
  while (v === 0) v = rng()
  return mean + sd * Math.sqrt(-2 * Math.log(u)) * Math.cos(2 * Math.PI * v)
}

function quantile(sorted, q) {
  var pos = (sorted.length - 1) * q
  var b = Math.floor(pos)
  var r = pos - b
  return sorted[b + 1] !== undefined
    ? sorted[b] + r * (sorted[b + 1] - sorted[b])
    : sorted[b]
}

// For each region draw a sample, then derive both the 5-number summary (the box)
// and keep the raw observations (the overlaid points).
function buildBox(name, n, mean, sd) {
  var data = []
  for (var i = 0; i < n; i++) data.push(Math.round(gauss(mean, sd) * 10) / 10)
  var s = data.slice().sort(function (a, b) {
    return a - b
  })
  return {
    x: name,
    y: [
      s[0],
      quantile(s, 0.25),
      quantile(s, 0.5),
      quantile(s, 0.75),
      s[s.length - 1],
    ],
    points: data,
  }
}

var REGIONS = [
  buildBox('North', 45, 68, 8),
  buildBox('South', 45, 74, 6),
  buildBox('East', 45, 61, 11),
  buildBox('West', 45, 70, 7),
]

const ApexChart = () => {
  const [state, setState] = React.useState({
    series: [
      {
        name: 'Response time',
        type: 'boxPlot',
        data: REGIONS,
      },
    ],
    options: {
      chart: {
        type: 'boxPlot',
        height: 460,
      },
      title: {
        text: 'Response time distribution by region',
      },
      plotOptions: {
        bar: {
          horizontal: true,
          barHeight: '50%',
        },
        boxPlot: {
          colors: { upper: '#5b8def', lower: '#a3c0f9' },
          // overlay each raw observation as a jittered dot
          points: { show: true, size: 3, jitter: 0.6 },
        },
      },
      stroke: { colors: ['#37474f'] },
    },
  })

  return (
    <div>
      <div id="chart">
        <ReactApexChart
          options={state.options}
          series={state.series}
          type="boxPlot"
          height={460}
        />
      </div>
    </div>
  )
}

export default ApexChart